/*******************************************************************************
 * FoxSettingsUICrosshair generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSettingsUICrosshair extends FoxSettingsUIBase within FoxMenuUI
    config(UI);

const NUM_MENU_CROSSHAIRS = 2;
const CROSSHAIR_LENGTH_MULTIPLIER = 2;

enum ECrosshairSettings
{
    ECS_StaticCrosshair,
    ECS_SmartReticleOpacity,
    ECS_CrosshairTickMarks,
    ECS_CrosshairTickLength,
    ECS_CrosshairRotation,
    ECS_CrosshairOpacity,
    ECS_CrosshairNeutralColor,
    ECS_CrosshairFriendlyColor,
    ECS_CrosshairEnemyInRangeColor,
    ECS_CrosshairEnemyOutOfRangeColor,
    ECS_Max
};

struct ColorDropDownInfo
{
    var string sLabel;
    var string sColor;

    structdefaultproperties
    {
        sLabel=""
        sColor=""
    }
};

var private FoxSettingsWidgetCrosshair MenuCrosshair;

function SetupSettingsScene()
{
    local int I;
    local array<string> OpacityStrings, TickMarksStrings, TickLengthStrings, CrosshairRotationStrings;
    local array<ColorDropDownInfo> NeutralData, FriendlyData, EnemyInRangeData, EnemyOutRangeData;
    local ColorDropDownInfo NewColorDropDownInfo;

    Outer.as_addAdditionalButtonContainer("container", int(SettingsContainerProperties.X), int(SettingsContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsContainerProperties.WidgetSpacing, SettingsContainerProperties.MaxListWidth, SettingsContainerProperties.MaxListHeight, true);
    as_addSettingsBG(0, 0);
    Outer.as_addAdditionalSettingsButtonContainer("game", int(SettingsDividerContainerProperties.X), int(SettingsDividerContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsDividerContainerProperties.WidgetSpacing, SettingsDividerContainerProperties.MaxListWidth, SettingsDividerContainerProperties.MaxListHeight, false);
    I = 0;
    J0x19A:
    // End:0x6F0 [Loop If]
    if(I < Outer.Outer.CrosshairColors.Length)
    {
        NewColorDropDownInfo.sLabel = Outer.LocalizeMenuString(Outer.Outer.CrosshairColors[I].Name);
        NewColorDropDownInfo.sColor = Outer.Outer.CrosshairColors[I].Color;
        NeutralData.AddItem(NewColorDropDownInfo);
        FriendlyData.AddItem(NewColorDropDownInfo);
        EnemyInRangeData.AddItem(NewColorDropDownInfo);
        EnemyOutRangeData.AddItem(NewColorDropDownInfo);
        // End:0x41B
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultNeutralColor)
        {
            NeutralData[I].sLabel @= (("(" $ Outer.LocalizeMenuString("Default")) $ ")");
        }
        // End:0x508
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultFriendlyColor)
        {
            FriendlyData[I].sLabel @= (("(" $ Outer.LocalizeMenuString("Default")) $ ")");
        }
        // End:0x5F5
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultEnemyInRangeColor)
        {
            EnemyInRangeData[I].sLabel @= (("(" $ Outer.LocalizeMenuString("Default")) $ ")");
        }
        // End:0x6E2
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultEnemyOutRangeColor)
        {
            EnemyOutRangeData[I].sLabel @= (("(" $ Outer.LocalizeMenuString("Default")) $ ")");
        }
        ++ I;
        // [Loop Continue]
        goto J0x19A;
    }
    OpacityStrings.AddItem("00 | 10");
    I = 1;
    J0x711:
    // End:0x77B [Loop If]
    if(I < 10)
    {
        OpacityStrings.AddItem(("0" $ string(I)) $ " | 10");
        TickLengthStrings.AddItem(("0" $ string(I)) $ " | 10");
        ++ I;
        // [Loop Continue]
        goto J0x711;
    }
    OpacityStrings.AddItem("10 | 10");
    TickLengthStrings.AddItem("10 | 10");
    I = 1;
    J0x7B2:
    // End:0x81C [Loop If]
    if(I <= 12)
    {
        TickMarksStrings.AddItem(((I < 10) ? ("0" $ string(I)) $ " | 12" : string(I) $ " | 12"));
        ++ I;
        // [Loop Continue]
        goto J0x7B2;
    }
    I = 0;
    J0x827:
    // End:0x866 [Loop If]
    if(I <= 7)
    {
        CrosshairRotationStrings.AddItem(string(I * 45) $ "?");
        ++ I;
        // [Loop Continue]
        goto J0x827;
    }
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("StaticCrosshair"), Outer.LocalizeMenuString("StaticCrosshairToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(0)), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("SmartReticle"), Outer.LocalizeMenuString("SmartReticleToolTip"), OpacityStrings, 0, "ei_SettingChanged", string(1), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("TickMarksLabel"), Outer.LocalizeMenuString("TickMarksTooltip"), TickMarksStrings, 0, "ei_SettingChanged", string(2), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("TickLengthLabel"), Outer.LocalizeMenuString("TickLengthTooltip"), TickLengthStrings, 0, "ei_SettingChanged", string(3), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("CrosshairRotationLabel"), Outer.LocalizeMenuString("CrosshairRotationTooltip"), CrosshairRotationStrings, 0, "ei_SettingChanged", string(4), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("CrosshairOpacityLabel"), Outer.LocalizeMenuString("CrosshairOpacityTooltip"), OpacityStrings, 0, "ei_SettingChanged", string(5), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(as_AddColorStepper("NeutralColorLabel", "NeutralColorTooltip", NeutralData, "ei_SettingChanged", string(6)), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(as_AddColorStepper("FriendlyColorLabel", "FriendlyColorTooltip", FriendlyData, "ei_SettingChanged", string(7)), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(as_AddColorStepper("InRangeColorLabel", "InRangeColorTooltip", EnemyInRangeData, "ei_SettingChanged", string(8)), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(as_AddColorStepper("FarRangeColorLabel", "FarRangeColorTooltip", EnemyOutRangeData, "ei_SettingChanged", string(9)), class'FoxSettingsWidget')));
    MenuCrosshair = FoxSettingsWidgetCrosshair(Outer.Outer.GetVariableObject(as_AddMenuCrosshair(), class'FoxSettingsWidgetCrosshair'));
    ei_SettingChanged(string(1), "0");
    ei_SettingChanged(string(2), "0");
    ei_SettingChanged(string(3), "0");
    ei_SettingChanged(string(4), "0");
    ei_SettingChanged(string(5), "0");
    ei_SettingChanged(string(6), "0");
    ei_SettingChanged(string(7), "0");
    ei_SettingChanged(string(8), "0");
    ei_SettingChanged(string(9), "0");
    //return;    
}

function GetOriginalVals()
{
    OriginalVals[1] = float(ProfileSettings.GetSettingInt(102) / 10);
    OriginalVals[0] = float(((ProfileSettings.IsSettingEnabled(115)) ? 1 : 0));
    OriginalVals[2] = float(ProfileSettings.GetSettingInt(103) - 1);
    OriginalVals[3] = float((ProfileSettings.GetSettingInt(106) / 2) - 1);
    OriginalVals[4] = float(ProfileSettings.GetSettingInt(104) / 45);
    OriginalVals[5] = float(ProfileSettings.GetSettingInt(105) / 10);
    OriginalVals[6] = float(ProfileSettings.GetSettingInt(107));
    OriginalVals[7] = float(ProfileSettings.GetSettingInt(108));
    OriginalVals[8] = float(ProfileSettings.GetSettingInt(109));
    OriginalVals[9] = float(ProfileSettings.GetSettingInt(110));
    //return;    
}

function GetDefaultVals()
{
    local int I;

    DefaultVals[1] = float(ProfileSettings.GetDefaultInt(102) / 10);
    DefaultVals[0] = float(((ProfileSettings.IsDefaultSettingEnabled(115)) ? 1 : 0));
    DefaultVals[2] = float(ProfileSettings.GetDefaultInt(103) - 1);
    DefaultVals[3] = float((ProfileSettings.GetDefaultInt(106) / 2) - 1);
    DefaultVals[4] = float(ProfileSettings.GetDefaultInt(104) / 45);
    DefaultVals[5] = float(ProfileSettings.GetDefaultInt(105) / 10);
    I = 0;
    J0x154:
    // End:0x42C [Loop If]
    if(I < Outer.Outer.CrosshairColors.Length)
    {
        // End:0x238
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultNeutralColor)
        {
            DefaultVals[6] = float(I);
        }
        // End:0x2DA
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultFriendlyColor)
        {
            DefaultVals[7] = float(I);
        }
        // End:0x37C
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultEnemyInRangeColor)
        {
            DefaultVals[8] = float(I);
        }
        // End:0x41E
        if(Outer.Outer.CrosshairColors[I].Name ~= Outer.Outer.CrosshairDefaultEnemyOutRangeColor)
        {
            DefaultVals[9] = float(I);
        }
        ++ I;
        // [Loop Continue]
        goto J0x154;
    }
    //return;    
}

function ApplyChanges()
{
    ProfileSettings.SetSettingValueInt(102, int(CurrentVals[1] * float(10)));
    ProfileSettings.SetSettingEnabled(115, ((CurrentVals[0] == float(1)) ? true : false));
    ProfileSettings.SetSettingValueInt(103, int(CurrentVals[2] + float(1)));
    ProfileSettings.SetSettingValueInt(106, int((CurrentVals[3] + float(1)) * float(2)));
    ProfileSettings.SetSettingValueInt(104, int(CurrentVals[4] * float(45)));
    ProfileSettings.SetSettingValueInt(105, int(CurrentVals[5] * float(10)));
    ProfileSettings.SetSettingValueInt(107, int(CurrentVals[6]));
    ProfileSettings.SetSettingValueInt(108, int(CurrentVals[7]));
    ProfileSettings.SetSettingValueInt(109, int(CurrentVals[8]));
    ProfileSettings.SetSettingValueInt(110, int(CurrentVals[9]));
    Outer.Outer.PCOwner.ApplyCrosshairSettings();
    //return;    
}

function ei_SettingChanged(string WidgetIndexString, string NewSelectedIndexString)
{
    local int WidgetIndex, NewSelectedIndex;

    WidgetIndex = int(WidgetIndexString);
    NewSelectedIndex = int(NewSelectedIndexString);
    super.ei_SettingChanged(WidgetIndexString, NewSelectedIndexString);
    // End:0x72
    if(WidgetIndex == 1)
    {
        UpdateReticleAlpha(NewSelectedIndex * 10);
    }
    // End:0x1C7
    else
    {
        // End:0x9D
        if(WidgetIndex == 2)
        {
            UpdateCrosshairTicks(NewSelectedIndex + 1);
        }
        // End:0x1C7
        else
        {
            // End:0xCC
            if(WidgetIndex == 3)
            {
                UpdateCrosshairLength((NewSelectedIndex + 1) * 2);
            }
            // End:0x1C7
            else
            {
                // End:0xF8
                if(WidgetIndex == 4)
                {
                    UpdateCrosshairRotation(NewSelectedIndex * 45);
                }
                // End:0x1C7
                else
                {
                    // End:0x124
                    if(WidgetIndex == 5)
                    {
                        UpdateCrosshairAlpha(NewSelectedIndex * 10);
                    }
                    // End:0x1C7
                    else
                    {
                        // End:0x14D
                        if(WidgetIndex == 6)
                        {
                            UpdateCrosshairColor(NewSelectedIndex, 0);
                        }
                        // End:0x1C7
                        else
                        {
                            // End:0x176
                            if(WidgetIndex == 7)
                            {
                                UpdateCrosshairColor(NewSelectedIndex, 1);
                            }
                            // End:0x1C7
                            else
                            {
                                // End:0x1A0
                                if(WidgetIndex == 8)
                                {
                                    UpdateCrosshairColor(NewSelectedIndex, 2);
                                }
                                // End:0x1C7
                                else
                                {
                                    // End:0x1C7
                                    if(WidgetIndex == 9)
                                    {
                                        UpdateCrosshairColor(NewSelectedIndex, 3);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    //return;    
}

private final function UpdateReticleAlpha(int NewAlpha)
{
    MenuCrosshair.as_UpdateReticleAlpha(NewAlpha);
    //return;    
}

private final function UpdateCrosshairTicks(int NumTicks)
{
    MenuCrosshair.as_UpdateCrosshairTicks(NumTicks);
    //return;    
}

private final function UpdateCrosshairLength(int NewLength)
{
    MenuCrosshair.as_UpdateCrosshairLength(NewLength);
    //return;    
}

private final function UpdateCrosshairRotation(int NewRotation)
{
    MenuCrosshair.as_UpdateCrosshairRotation(NewRotation);
    //return;    
}

private final function UpdateCrosshairAlpha(int NewAlpha)
{
    MenuCrosshair.as_UpdateCrosshairAlpha(NewAlpha);
    //return;    
}

private final function UpdateCrosshairColor(int NewColorIndex, int WidgetIndex)
{
    local array<int> NewColors;

    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].R);
    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].RO);
    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].G);
    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].GO);
    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].B);
    NewColors.AddItem(Outer.Outer.CrosshairColors[NewColorIndex].BO);
    MenuCrosshair.as_UpdateCrosshairColor(NewColors);
    //return;    
}

private final function string as_AddMenuCrosshair()
{
    return Outer.Outer.ActionScriptString("_root.addMenuCrosshair");
    //return ReturnValue;    
}

private final function string as_AddColorDropDownMenu(string Label, string ToolTip, array<ColorDropDownInfo> Data, string extClickInterfaceFunc, string ExtClickFuncArg, optional int InitialIndex)
{
    Label = Outer.LocalizeMenuString(Label);
    ToolTip = Outer.LocalizeMenuString(ToolTip);
    return Outer.Outer.ActionScriptString("_root.addColorDropDownMenu");
    //return ReturnValue;    
}

private final function string as_AddColorStepper(string Label, string ToolTip, array<ColorDropDownInfo> Data, string extClickInterfaceFunc, string ExtClickFuncArg, optional int InitialIndex)
{
    Label = Outer.LocalizeMenuString(Label);
    ToolTip = Outer.LocalizeMenuString(ToolTip);
    return Outer.Outer.ActionScriptString("_root.addColorStepper");
    //return ReturnValue;    
}
